package com.gic.haoban.manage.web.qo.eventtracking;

import com.alibaba.fastjson.JSONObject;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.gic.haoban.manage.web.qo.wechatwork.StoreGroupCommonQO;
import lombok.Data;
import org.apache.commons.lang3.StringUtils;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;

/**
 * @Author guojx
 * @Date 2024/5/22 9:27
 */
@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class WechatEventTrackingStoreGroupQO extends StoreGroupCommonQO implements Serializable {
    /**
     * 周期起始时间
     */
    private String startDate;

    /**
     * 结束时间
     */
    private String endDate;

    /**
     * 数据类型 1天 2近7天 3近30天 4周 5月
     */
    private Integer dateType;

    /**
     * 排序类型 1 正序  2 倒序
     */
    private Integer orderByType;

    /**
     * 排序字段名称
     */
    private String orderByFields;

    private Integer pageNum;

    private Integer pageSize;


    /**
     * 下载导出参数：数据脱敏 1:脱敏 2:完整
     */
    private Integer dataType = 1;

    /**
     * 下载导出参数：为了兼容前端传参
     */
    private String requestProject;

    public Integer getDataApiOrderField() {
        Map<String, Integer> map = new HashMap<>(8);
        map.put("clerkNum", 1);
        map.put("bindingNum", 2);
        map.put("bindingRate", 3);
        map.put("visitNum", 4);
        map.put("visitRate", 5);
        map.put("visitCnt", 6);
        return map.get(orderByFields) == null ? 1 : map.get(orderByFields);
    }

    public void dealWithParam(JSONObject jsonObject) {
        if (jsonObject == null) {
            jsonObject = new JSONObject();
        }
        if (StringUtils.isNotBlank(startDate)) {
            jsonObject.put("startDate", startDate);
        }
        if (dateType != null) {
            jsonObject.put("dateType", dateType);
        }
        if (orderByType != null) {
            jsonObject.put("orderByType", orderByType);
        }
        if (orderByFields != null) {
            jsonObject.put("orderByFields", orderByFields);
        }
        jsonObject.put("pageNum", pageNum);
        jsonObject.put("pageSize", pageSize);
    }
}
